﻿Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Private pinchStartDistance As Double
    Private pinchStartAngle As Double

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub OnGestureListenerDragStarted(ByVal sender As Object, ByVal args As DragStartedGestureEventArgs)
        ellipse1.Visibility = Visibility.Visible
        ellipseGeo1.Center = args.GetPosition(ContentPanel)
    End Sub

    Private Sub OnGestureListenerDragDelta(ByVal sender As Object, ByVal args As DragDeltaGestureEventArgs)
        ellipseGeo1.Center = args.GetPosition(ContentPanel)
    End Sub

    Private Sub OnGestureListenerDragCompleted(ByVal sender As Object, ByVal args As DragCompletedGestureEventArgs)
        ellipse1.Visibility = Visibility.Collapsed
    End Sub

    Private Sub OnGestureListenerPinchStarted(ByVal sender As Object, ByVal args As PinchStartedGestureEventArgs)
        ellipse1.Visibility = Visibility.Visible
        ellipse2.Visibility = Visibility.Visible

        Dim pt1 = args.GetPosition(ContentPanel)
        Dim pt2 As New Point(pt1.X + args.Distance * Cos(args.Angle),
                             pt1.Y + args.Distance * Sin(args.Angle))

        ellipseGeo1.Center = pt1
        ellipseGeo2.Center = pt2

        pinchStartDistance = args.Distance
        pinchStartAngle = args.Angle
    End Sub

    Private Sub OnGestureListenerPinchDelta(ByVal sender As Object, ByVal args As PinchGestureEventArgs)
        Dim pt1 = args.GetPosition(ContentPanel)

        Dim distance = args.DistanceRatio * pinchStartDistance
        Dim angle = args.TotalAngleDelta + pinchStartAngle

        Dim pt2 As New Point(pt1.X + distance * Cos(angle), pt1.Y + distance * Sin(angle))

        ellipseGeo1.Center = pt1
        ellipseGeo2.Center = pt2
    End Sub

    Private Sub OnGestureListenerPinchCompleted(ByVal sender As Object, ByVal args As PinchGestureEventArgs)
        ellipse1.Visibility = Visibility.Collapsed
        ellipse2.Visibility = Visibility.Collapsed
    End Sub

    Private Function Sin(ByVal angle As Double) As Double
        Return Math.Sin(Math.PI * angle / 180)
    End Function

    Private Function Cos(ByVal angle As Double) As Double
        Return Math.Cos(Math.PI * angle / 180)
    End Function
End Class